<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks® NonCommercial, 7.3 of vendredi 3 décembre 2004 on mercredi 12 avril 2006 at 1:43:44</time-stamp>


<name-space>
<name>Atoll</name>
<environment>CormasNS.Models</environment>
<private>false</private>
<imports>
			private Smalltalk.*
			private CormasNS.Kernel.*
			</imports>
<category>AtollCategory</category>
<attributes>
<package>Atoll</package>
</attributes>
</name-space>


<class>
<name>Household</name>
<environment>CormasNS.Models.Atoll</environment>
<super>CormasNS.Kernel.AgentCommLocation</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>agentPUB dicoWaterConsumptions indexNonSatisfaction myLand myRainTank myTap myWell relatives sizeHH waterConsumptionMemory waterDemands waterDemandsMemory waterUses </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>AtollCategory</category>
<attributes>
<package>Atoll</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Atoll.Household class</class-id> <category>parameters</category>

<body package="Atoll" selector="drinkWaterEquipments">drinkWaterEquipments
	^#(#RainTank #Tap #Well)</body>

<body package="Atoll" selector="needForAgriculture">needForAgriculture
	^100 * 10</body>

<body package="Atoll" selector="needForDrink">needForDrink
	^20 * 10</body>

<body package="Atoll" selector="needForToilet">needForToilet
	^40 * 10</body>

<body package="Atoll" selector="toiletWaterEquipments">toiletWaterEquipments
	^#(#Tap #Well)</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Atoll.Household</class-id> <category>init</category>

<body package="Atoll" selector="createNewRelativesIn:">createNewRelativesIn: aCollecOfCells 
	"create a new relative in each cell of the collection aCollecOfCells"

	| collec nH location |
	collec := OrderedCollection new.
	
	1 to: aCollecOfCells size
		do: 
			[:i | 
			nH := Relative new.
			collec add: nH.
			location := aCollecOfCells at: i.
			(location theOccupants at: #Relative) isEmpty ifFalse: [self halt].
			nH initOnCell: location.
			nH agentPUB: self agentPUB.
			self relatives add: nH.
			nH sizeHH: (Cormas randomFrom: 10 to: self myIsland maxSizeHH).
			nH initWaterEquipments].
	^collec</body>

<body package="Atoll" selector="init:ownership:">init: c ownership: aBoolean 
	super init.
	self sizeHH: 0.
	self indexNonSatisfaction: 0.
	self moveTo: c.
	aBoolean 
		ifTrue: 
			[self myLand: (c theCSE at: #LandStripe).
			self myLand landowner: self]</body>

<body package="Atoll" selector="initOnCell:">initOnCell: c
	super init.
	self sizeHH: 0.
	self indexNonSatisfaction: 0.
	self moveTo: c.</body>

<body package="Atoll" selector="initWaterEquipments">initWaterEquipments
	self addWaterEquipment: Well. 
	self addTap.
	self addRainTank</body>

<body package="Atoll" selector="newRelativesLocations:">newRelativesLocations: aNumber 
	| newCollec collec aCell test |
" select aNumber of cells amongst the empty ones, returns the collection of cells "
	newCollec := OrderedCollection new.
	collec := self myLand emptyPlaces copy.
	aNumber timesRepeat: 
			[aCell := Cormas selectRandomlyFrom: collec.
			newCollec add: aCell.
			collec remove: aCell].
	test := newCollec select: [:c | (c theOccupants at: #Player) isEmpty not or: [(c theOccupants at: #Relative) isEmpty not]].
	test isEmpty ifFalse: [self halt].
	^newCollec</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Household</class-id> <category>control</category>

<body package="Atoll" selector="step">step
	"to be completed"</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Household</class-id> <category>accessing</category>

<body package="Atoll" selector="agentPUB">agentPUB
	"Getter accessor without default value "
	^agentPUB</body>

<body package="Atoll" selector="agentPUB:">agentPUB: anObject 
	agentPUB := anObject</body>

<body package="Atoll" selector="dicoWaterConsumptions">dicoWaterConsumptions
	" A dico of dico. For each Use, the list of available WaterEquipment and the waterConsumptions asked by the HH"

	dicoWaterConsumptions ifNil: 
			[dicoWaterConsumptions := Dictionary new.
			self waterUses do: [:k | dicoWaterConsumptions at: k put: Dictionary new]].
	^dicoWaterConsumptions</body>

<body package="Atoll" selector="dicoWaterConsumptions:">dicoWaterConsumptions: anObject 
	dicoWaterConsumptions := anObject</body>

<body package="Atoll" selector="distanceToPipe">distanceToPipe
	| pipeCell |
	pipeCell := (self patch myIsland components 
				select: [:c | c numCol = self patch numCol]) detect: [:c | c waterPipe]
					ifNone: [nil].
	^self patch distCell: pipeCell</body>

<body package="Atoll" selector="indexNonSatisfaction">indexNonSatisfaction
	"Getter accessor without default value "
	^indexNonSatisfaction</body>

<body package="Atoll" selector="indexNonSatisfaction:">indexNonSatisfaction: anObject 
	indexNonSatisfaction := anObject</body>

<body package="Atoll" selector="myIsland">myIsland
	^self patch theCSE detect: [:e | e isKindOf: Island] ifNone: [nil]</body>

<body package="Atoll" selector="myLand">myLand
	"Getter accessor without default value "
	^myLand</body>

<body package="Atoll" selector="myLand:">myLand: anObject 
	myLand := anObject</body>

<body package="Atoll" selector="myRainTank">myRainTank
	"Getter accessor without default value "
	^myRainTank</body>

<body package="Atoll" selector="myRainTank:">myRainTank: anObject 
	myRainTank := anObject</body>

<body package="Atoll" selector="myTap">myTap
	"Getter accessor without default value "
	^myTap</body>

<body package="Atoll" selector="myTap:">myTap: anObject 
	myTap := anObject</body>

<body package="Atoll" selector="myWell">myWell
	"Getter accessor without default value "
	^myWell</body>

<body package="Atoll" selector="myWell:">myWell: anObject 
	myWell := anObject</body>

<body package="Atoll" selector="nbNewRelatives">nbNewRelatives
" select randomly between 1 and 6 cells to locate new relatives. If the number of empty land cells available is lower than 6, the random is between 1 and the number of empty cells left"
"myLand returns the aggregate landStripe" 

	self myLand emptyPlaces isEmpty ifTrue: [^0].
	^Cormas randomFrom: 1 to: (6 min: self myLand emptyPlaces size)</body>

<body package="Atoll" selector="relatives">relatives
	"Getter accessor without default value "
	^relatives</body>

<body package="Atoll" selector="relatives:">relatives: anObject 
	relatives := anObject</body>

<body package="Atoll" selector="sizeHH">sizeHH
	"Getter accessor without default value "
	^sizeHH</body>

<body package="Atoll" selector="sizeHH:">sizeHH: anObject 
	sizeHH := anObject</body>

<body package="Atoll" selector="waterConsumptionMemory">waterConsumptionMemory
	waterConsumptionMemory 
		ifNil: [waterConsumptionMemory := OrderedCollection new].
	^waterConsumptionMemory</body>

<body package="Atoll" selector="waterConsumptionMemory:">waterConsumptionMemory: anObject 
	waterConsumptionMemory := anObject</body>

<body package="Atoll" selector="waterDemands">waterDemands
	waterDemands ifNil: [waterDemands := Dictionary new].
	^waterDemands</body>

<body package="Atoll" selector="waterDemands:">waterDemands: anObject 
	waterDemands := anObject</body>

<body package="Atoll" selector="waterDemandsMemory">waterDemandsMemory
	waterDemandsMemory ifNil: [waterDemandsMemory := OrderedCollection new].
	^waterDemandsMemory</body>

<body package="Atoll" selector="waterDemandsMemory:">waterDemandsMemory: anObject 
	waterDemandsMemory := anObject</body>

<body package="Atoll" selector="waterUses">waterUses
	waterUses ifNil: [waterUses := #(#Drink #Toilet)].
	^waterUses</body>

<body package="Atoll" selector="waterUses:">waterUses: anObject 
	waterUses := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Household</class-id> <category>water eqiupment</category>

<body package="Atoll" selector="addRainTank">addRainTank
	Cormas random &lt; 0.1 ifTrue: [self addWaterEquipment: RainTank]</body>

<body package="Atoll" selector="addTap">addTap
	(self patch myIsland name = #south and: [self distanceToPipe &lt; 8]) 
		ifTrue: [self addWaterEquipment: Tap]</body>

<body package="Atoll" selector="addWaterEquipment:">addWaterEquipment: aClass 
	| aWU |
	aWU := aClass new.
	aWU initEquipment: self</body>

<body package="Atoll" selector="availableEquipmentForUse:">availableEquipmentForUse: aUseName 

"return the collection of the household's WaterEquipments available for a specific use.
(self class environment at: aUseName) returns the class Drink, Toilet or Agriculture.
((self class environment at: aUseName) waterEquipments) returns all the existing WaterEquipments available for a specific use" 

	| collec |
	collec := OrderedCollection new.
	aUseName = #Drink ifTrue: [self class drinkWaterEquipments do: 
			[:aWE | 
			(self perform: ('my' , aWE asString) asSymbol) notNil 
				ifTrue: [collec add: aWE]].
	^collec].
	aUseName = #Toilet ifTrue: [self class toiletWaterEquipments do: 
			[:aWE | 
			(self perform: ('my' , aWE asString) asSymbol) notNil 
				ifTrue: [collec add: aWE]].
	^collec]</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Household</class-id> <category>water needs</category>

<body package="Atoll" selector="calculWaterDemands">calculWaterDemands
	"waterUses = collection of uses (#Drink, #Toilet) per default.
	waterDemands = dico  with (key = aUse) and (value = aWaterDemand).
	So far, the waterDemand is the recommanded one, not the wanted one"

	self waterUses do: 
			[:k | 
			self waterDemands at: k
				put: (self perform: ('needsFor' , k asString) asSymbol)].
	self waterDemandsMemory add: self copyWaterDemands</body>

<body package="Atoll" selector="copyWaterConsumptions">copyWaterConsumptions
	| copy |
	copy := Dictionary new.
	self dicoWaterConsumptions keysAndValuesDo: 
			[:kUse :vUse | 
			copy at: kUse put: Dictionary new.
			vUse keysAndValuesDo: [:kWE :vWE | (copy at: kUse) at: kWE put: vWE]].
	^copy</body>

<body package="Atoll" selector="copyWaterDemands">copyWaterDemands
	| copy |
	copy := Dictionary new.
	self waterDemands keysAndValuesDo: [:kUse :vUse | copy at: kUse put: vUse].
	^copy</body>

<body package="Atoll" selector="needsForAgriculture">needsForAgriculture
	"return the recommanded quantity for drink, in L per timeStep"

	^Household needForAgriculture * self sizeHH</body>

<body package="Atoll" selector="needsForDrink">needsForDrink
	"return the recommanded quantity for drink, in L per timeStep"

	^Household needForDrink * self sizeHH</body>

<body package="Atoll" selector="needsForToilet">needsForToilet
	"return the recommanded quantity for drink, in L per timeStep"

	^Household needForToilet * self sizeHH</body>

<body package="Atoll" selector="updateWaterConsumption">updateWaterConsumption
	"for each Use, sends the method to calculate the water consummed per equipment available for this purpose"

	self waterUses do: [:k | self perform: #waterConsumptionUse: with: k].
	self waterConsumptionMemory add: self copyWaterConsumptions</body>

<body package="Atoll" selector="waterConsumptionUse:">waterConsumptionUse: aUseName 
"indicates for a specific Use the water consumed per WaterEquipment available for this purpose"
	| availableWEs demand i aWE waterQty |
	self dicoWaterConsumptions at: aUseName put: Dictionary new.
	availableWEs := self availableEquipmentForUse: aUseName.
	demand := self waterDemands at: aUseName.
	i := 1.
	[demand &gt; 0 and: [i &lt;= availableWEs size]] whileTrue: 
			[aWE := self perform: ('my', (availableWEs at: i) asString) asSymbol.
			waterQty := (aWE giveWater: demand).
			(self dicoWaterConsumptions at: aUseName) at: (availableWEs at: i) put: waterQty.
			demand := demand - waterQty.
			i := i+1]</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Household</class-id> <category>water uses</category>

<body package="Atoll" selector="totalConsumptionForEq:">totalConsumptionForEq: aWE 
"returns the global amount of water consummed per WaterEquipment"
	| tot |
	tot := 0.
	self waterUses do: [:aUseName | tot := tot + (((self dicoWaterConsumptions at: aUseName)
						includesKey: aWE)
						ifTrue: [(self dicoWaterConsumptions at: aUseName)
								at: aWE]
						ifFalse: [0])].
	^tot</body>
</methods>


<class>
<name>Player</name>
<environment>CormasNS.Models.Atoll</environment>
<super>CormasNS.Models.Atoll.Household</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>name </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>AtollCategory</category>
<attributes>
<package>Atoll</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.Atoll.Player</class-id> <category>control</category>

<body package="Atoll" selector="step">step
	"to be completed"</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Player</class-id> <category>accessing</category>

<body package="Atoll" selector="name">name
	"Getter accessor without default value "
	^name</body>

<body package="Atoll" selector="name:">name: anObject 
	name := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Player</class-id> <category>pov</category>

<body package="Atoll" selector="povPlayer">povPlayer
	^self class name</body>
</methods>


<class>
<name>HouseholdCharts</name>
<environment>CormasNS.Models.Atoll</environment>
<super>UI.SimpleDialog</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>plotsDataDrinking household </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Cormas - Atoll</category>
<attributes>
<package>Atoll</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Atoll.HouseholdCharts class</class-id> <category>interface specs</category>

<body package="Atoll" selector="drinkingChart">drinkingChart
	"UIPainter new openOnClass: self andSelector: #drinkingChart"

	&lt;resource: #canvas&gt;
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: 'Drinking allocation' 
			#min: #(#{Core.Point} 20 20 ) 
			#bounds: #(#{Graphics.Rectangle} 512 384 777 575 ) ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.ChartViewSpec} 
					#layout: #(#{Graphics.LayoutFrame} 5 0 5 0 -5 1 -5 1 ) 
					#model: #plotsDataDrinking 
					#chartType: #BG_StackedBarChartView 
					#dataSeries: 
					#(#{UI.ChartDataSpec} 
						#series: #(
							#(#{UI.ChartDataSetSpec} 
								#name: 'Rain Tank' 
								#look: 
								#(#{UI.ChartElementLookSpec} 
									#foregroundColor: #(#{Graphics.ColorValue} #black ) 
									#backgroundColor: #(#{Graphics.ColorValue} 4096 0 8191 ) ) ) 
							#(#{UI.ChartDataSetSpec} 
								#name: 'PUB Tap' 
								#look: 
								#(#{UI.ChartElementLookSpec} 
									#backgroundColor: #(#{Graphics.ColorValue} 1024 1024 8191 ) ) ) 
							#(#{UI.ChartDataSetSpec} 
								#isData: true 
								#name: 'Well' 
								#look: 
								#(#{UI.ChartElementLookSpec} 
									#backgroundColor: #(#{Graphics.ColorValue} 3072 5631 8191 ) ) ) 
							#(#{UI.ChartDataSetSpec} 
								#name: ' ' 
								#look: 
								#(#{UI.ChartElementLookSpec} 
									#backgroundColor: #(#{Graphics.ColorValue} 6553 6553 6553 ) ) ) ) ) 
					#yAxis: 
					#(#{UI.ChartingValueAxisSpec} 
						#scale: 
						#(#{UI.ChartingScaleSpec} 
							#invert: true ) ) 
					#legendPosition: 2 ) ) ) )</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Atoll.HouseholdCharts</class-id> <category>aspects</category>

<body package="Atoll" selector="plotsDataDrinking">plotsDataDrinking
	| data i x |
	data := Array new: self household waterConsumptionsMemory size.
	i := 0.
	self household waterConsumptionsMemory do: 
			[:aDict | 
			i := i + 1.
			x := Array new: 4.
			x at: 1
				put: (((aDict at: #Drink) includesKey: #RainTank) 
						ifTrue: [(aDict at: #Drink) at: #RainTank]
						ifFalse: [0]).
			x at: 2
				put: (((aDict at: #Drink) includesKey: #Tap) 
						ifTrue: [(aDict at: #Drink) at: #Tap]
						ifFalse: [0]).
			x at: 3
				put: (((aDict at: #Drink) includesKey: #Well) 
						ifTrue: [(aDict at: #Drink) at: #Well]
						ifFalse: [0]).
			x at: 4
				put: ((self household waterDemandsMemory at: i) at: #Drink) - (x at: 1) - (x at: 2) 
						- (x at: 3).
			data at: i put: x].
	^data</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.HouseholdCharts</class-id> <category>accessing</category>

<body package="Atoll" selector="household">household
	"Getter accessor without default value "
	^household</body>

<body package="Atoll" selector="household:">household: anObject 
	household := anObject</body>
</methods>


<class>
<name>AtollCell</name>
<environment>CormasNS.Models.Atoll</environment>
<super>CormasNS.Kernel.SpatialEntityCell</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>cellLanduse depth distanceToPipeEntry dwelling gallery landStripe lensCenter lensCenterL lensh lensH lossFromGalleries reserve risk typeLanduse waterPipe wellLoss wellWaterQuality </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>AtollCategory</category>
<attributes>
<package>Atoll</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Atoll.AtollCell class</class-id> <category>parameters</category>

<body package="Atoll" selector="cellArea">cellArea
	"490 m2 = pi * 12.5 * 12.5, rayon du cercle = 12.5m"

	^490</body>

<body package="Atoll" selector="epsilon">epsilon
	^0.03</body>

<body package="Atoll" selector="K">K
	^15

	"in meters/day"</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Atoll.AtollCell</class-id> <category>init</category>

<body package="Atoll" selector="initCellAttributes">initCellAttributes
	super init.
	self lensH: 0.
	self lensh: 0.
	self wellLoss: 0.
	self lossFromGalleries: 0.
	self risk: 0.
	(self state = #land) ifTrue: [(self reserve ~= 1) 	ifTrue: [self reserve: 0]] ifFalse: [self reserve: nil].
	self distanceToPipeEntry: self calculateDistanceToPipe.</body>

<body package="Atoll" selector="initCellLanduse:">initCellLanduse: aSymbol 
	| aLandUse |
	
	aLandUse := (self class environment at: aSymbol) new.
	aLandUse initLanduse.
	aLandUse isMovedTo: self.
	self cellLanduse: aLandUse.
	aLandUse patch isNil ifTrue: [self halt].
	^aLandUse</body>

<body package="Atoll" selector="initLensCenter">initLensCenter
	self lensCenter isNil
		ifTrue: [^self]
		ifFalse: [self extensiveNeighbourhood: (self recursiveNeighbourhood: self lensCenterL)]</body>

<body package="Atoll" selector="initZT:">initZT: aqQ 		"aqQ in mm / year"
	
| collec  qQo lambda cst Lx delta a H |

self extensiveNeighbourhood isNil ifTrue: [^self].
	qQo := (aqQ /(365000 * self class K * self class epsilon * (1 + self class epsilon))). 	"without dimension"
	lambda := (self class epsilon * self class K  * self L / ((qQo ** 0.5) * 0.02)).
	cst := (self L / ((qQo ** 0.5) * (lambda ** 0.5))).

1 to: self lensCenterL  do: [:i | 	collec := self peripherieRayon: i.
								collec 	do: 	[:c | Lx := ((self L ** 2) - ((i * 25) ** 2)).
												a := ((1 - ((Lx / (self L ** 2)) ** 0.5)) ** 0.5).
												delta := (cst * a * ((Lx ** 0.5) / (i * 25))).
												H := (((qQo) * ((self L** 2) - ((i * 25) ** 2))) ** 0.5).
												c lensH isNil ifTrue: 	[c lensH: (H - (delta/2))]
																	ifFalse: [c lensH: ((c lensH) max: (H - (delta/2)))].
												c lensh: c lensH * self class epsilon]].

self lensH: ((self neighbourhood first lensH) * 1.1).
self lensh: (self lensH * self class epsilon).</body>

<body package="Atoll" selector="updateWellWater">updateWellWater

self lensH = nil ifTrue: [^self].

self lensH &lt; 1.6 ifTrue: [self wellWaterQuality: #salty].
((self lensH &gt;= 1.6) and: [(self lensH &lt; 3.1)]) ifTrue: [self wellWaterQuality: #brackish].
self lensH &gt; 3.1 ifTrue: [self wellWaterQuality: #fresh].</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.AtollCell</class-id> <category>accessing</category>

<body package="Atoll" selector="cellLanduse">cellLanduse
	"Getter accessor without default value "
	^cellLanduse</body>

<body package="Atoll" selector="cellLanduse:">cellLanduse: anObject 
	cellLanduse := anObject</body>

<body package="Atoll" selector="collecAllWaterEquipments">collecAllWaterEquipments
| collec classNamesList |
	collec := OrderedCollection new.
	classNamesList := WaterEquipment allSubclasses collect: [:aCl | aCl name].
	classNamesList 
		do: [:aSymbol | collec addAll: (self collecWaterEquipment: aSymbol)].
	^collec</body>

<body package="Atoll" selector="collecWaterEquipment:">collecWaterEquipment: aSymbol 
	^self theOccupants at: aSymbol</body>

<body package="Atoll" selector="depth">depth
	"Getter accessor without default value "
	^depth</body>

<body package="Atoll" selector="depth:">depth: anObject 
	depth := anObject</body>

<body package="Atoll" selector="distanceToPipeEntry">distanceToPipeEntry
	"Getter accessor without default value "
	^distanceToPipeEntry</body>

<body package="Atoll" selector="distanceToPipeEntry:">distanceToPipeEntry: anObject 
	distanceToPipeEntry := anObject</body>

<body package="Atoll" selector="dwelling">dwelling
	"Getter accessor without default value "
	^dwelling</body>

<body package="Atoll" selector="dwelling:">dwelling: anObject 
	dwelling := anObject</body>

<body package="Atoll" selector="gallery">gallery
	"Getter accessor without default value "
	^gallery</body>

<body package="Atoll" selector="gallery:">gallery: anObject 
	gallery := anObject</body>

<body package="Atoll" selector="L">L
	^((self lensCenterL * 25) + 12.5)	"L en metres"</body>

<body package="Atoll" selector="landStripe">landStripe
	"Getter accessor without default value "
	^landStripe</body>

<body package="Atoll" selector="landStripe:">landStripe: anObject 
	landStripe := anObject</body>

<body package="Atoll" selector="lensCenter">lensCenter
	"Getter accessor without default value "
	^lensCenter</body>

<body package="Atoll" selector="lensCenter:">lensCenter: anObject 
	lensCenter := anObject</body>

<body package="Atoll" selector="lensCenterL">lensCenterL
	"Getter accessor without default value "
	^lensCenterL</body>

<body package="Atoll" selector="lensCenterL:">lensCenterL: anObject 
	lensCenterL := anObject</body>

<body package="Atoll" selector="lensH">lensH
	"Getter accessor without default value "
	^lensH</body>

<body package="Atoll" selector="lensh">lensh
	"Getter accessor without default value "
	^lensh</body>

<body package="Atoll" selector="lensH:">lensH: anObject 
	lensH := anObject</body>

<body package="Atoll" selector="lensh:">lensh: anObject 
	lensh := anObject</body>

<body package="Atoll" selector="lossFromGalleries">lossFromGalleries
	"Getter accessor without default value "
	^lossFromGalleries</body>

<body package="Atoll" selector="lossFromGalleries:">lossFromGalleries: anObject 
	lossFromGalleries := anObject</body>

<body package="Atoll" selector="myHouseHold">myHouseHold
	(self theOccupants at: #Player) isEmpty 
		ifFalse: [^(self theOccupants at: #Player) first].
	(self theOccupants at: #Relative) isEmpty 
		ifFalse: [^(self theOccupants at: #Relative) first].
	^nil</body>

<body package="Atoll" selector="myIsland">myIsland
	(self theCSE includesKey: #Island) ifTrue: [^self theCSE at: #Island].
^nil</body>

<body package="Atoll" selector="myWaterBalance">myWaterBalance
	^(self theOccupants at: #WaterBalance) first</body>

<body package="Atoll" selector="rainTank">rainTank
	^((self theOccupants includesKey: #RainTank) 
		and: [(self theOccupants at: #RainTank) notEmpty]) 
			ifTrue: [(self theOccupants at: #RainTank) first]
			ifFalse: [nil]</body>

<body package="Atoll" selector="reserve">reserve
	"Getter accessor without default value "
	^reserve</body>

<body package="Atoll" selector="reserve:">reserve: anObject 
	reserve := anObject</body>

<body package="Atoll" selector="risk">risk
	"Getter accessor without default value "
	^risk</body>

<body package="Atoll" selector="risk:">risk: anObject 
	risk := anObject</body>

<body package="Atoll" selector="tap">tap
	^((self theOccupants includesKey: #Tap) 
		and: [(self theOccupants at: #Tap) notEmpty]) 
			ifTrue: [(self theOccupants at: #Tap) first]
			ifFalse: [nil]</body>

<body package="Atoll" selector="typeLanduse">typeLanduse
	"Getter accessor without default value "
	^typeLanduse</body>

<body package="Atoll" selector="typeLanduse:">typeLanduse: anObject 
	typeLanduse := anObject</body>

<body package="Atoll" selector="waterPipe">waterPipe
	"Getter accessor without default value "
	^waterPipe</body>

<body package="Atoll" selector="waterPipe:">waterPipe: anObject 
	waterPipe := anObject</body>

<body package="Atoll" selector="well">well
	^((self theOccupants includesKey: #Well) 
		and: [(self theOccupants at: #Well) notEmpty]) 
			ifTrue: [(self theOccupants at: #Well) first]
			ifFalse: [nil]</body>

<body package="Atoll" selector="wellLoss">wellLoss
	"Getter accessor without default value "
	^wellLoss</body>

<body package="Atoll" selector="wellLoss:">wellLoss: anObject 
	wellLoss := anObject</body>

<body package="Atoll" selector="wellWaterQuality">wellWaterQuality
	"Getter accessor without default value "
	^wellWaterQuality</body>

<body package="Atoll" selector="wellWaterQuality:">wellWaterQuality: anObject 
	wellWaterQuality := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.AtollCell</class-id> <category>pov</category>

<body package="Atoll" selector="povAtollCell">povAtollCell
	self state = #none ifTrue: [^self state].
	self state = #land ifTrue: [^self state].
	self state = #lagoon ifTrue: [^self state].
	self state = #sea ifTrue: [^self state].</body>

<body package="Atoll" selector="povDepth">povDepth
	| seaColor lagoonColor alpha rv gv bv |
	self depth isNil ifTrue: [^ColorValue white].
	(self depth = 0 or: [self depth = 300 or: [self depth = 500]])
		ifTrue: [^self povAtollCell].
	seaColor := self class colorsDict at: #seaShore.
	lagoonColor := self class colorsDict at: #lagoonShore.
	alpha := (self depth - 300) / 200.
	rv := (seaColor scaledRed * alpha) rounded + (lagoonColor scaledRed * (1 - alpha)) rounded.
	gv := (seaColor scaledGreen * alpha) rounded + (lagoonColor scaledGreen * (1 - alpha)) rounded.
	bv := (seaColor scaledBlue * alpha) rounded + (lagoonColor scaledBlue * (1 - alpha)) rounded.
	^ColorValue
		scaledRed: rv
		scaledGreen: gv
		scaledBlue: bv</body>

<body package="Atoll" selector="povDistanceToPipeEntry">povDistanceToPipeEntry
	self distanceToPipeEntry = 9999 ifTrue: [^ColorValue white].
	^self 
		povAttribute: #distanceToPipeEntry
		min: 0
		max: 44
		color: ColorValue green</body>

<body package="Atoll" selector="povDwelling">povDwelling
	
	self dwelling = #relative ifTrue: [^ColorValue white].
	(self dwelling copyFrom: 1 to: 6) = 'player' ifTrue: [^ColorValue gray].
	self gallery = #yes ifTrue: [^ColorValue black].
	^self povAtollCell</body>

<body package="Atoll" selector="povLanduse">povLanduse
	
	self state = #lagoon ifTrue: [^self state].
	self state = #sea ifTrue: [^self state].
	self cellLanduse isNil 	ifTrue: [^ColorValue white]
							ifFalse:[(self cellLanduse class) = Tree ifTrue: [^ColorValue green].
									(self cellLanduse class) = Baresoil ifTrue: [^ColorValue brown].
									(self cellLanduse class) = Crop ifTrue: [^ColorValue orange]].</body>

<body package="Atoll" selector="povLensCenter">povLensCenter
	self lensCenter = 1 ifTrue: [^ColorValue green] ifFalse: [^self povAtollCell]</body>

<body package="Atoll" selector="povLensH">povLensH
	| CenterColor PeriColor alpha rv gv bv |
	self lensH isNil ifTrue: [^self povAtollCell].
	self lensH = 0 ifTrue: [^self povAtollCell].
	CenterColor := self class colorsDict at: #lensCenter.
	PeriColor := self class colorsDict at: #lensPeri.
	
	alpha := (self lensH) / 17.
	rv := (CenterColor scaledRed * alpha) rounded + (PeriColor scaledRed * (1 - alpha)) rounded.
	gv := (CenterColor scaledGreen * alpha) rounded + (PeriColor scaledGreen * (1 - alpha)) rounded.
	bv := (CenterColor scaledBlue * alpha) rounded + (PeriColor scaledBlue * (1 - alpha)) rounded.
	
^ColorValue
		scaledRed: rv
		scaledGreen: gv
		scaledBlue: bv</body>

<body package="Atoll" selector="povWaterPipe">povWaterPipe
	(self waterPipe isNil or: [self waterPipe not]) ifTrue: [^self povAtollCell].
	self waterPipe ifTrue: [^ColorValue black]</body>

<body package="Atoll" selector="povWE">povWE
	(self rainTank notNil and: [self tap notNil]) ifTrue: [^ColorValue red].
	self rainTank notNil ifTrue: [^ColorValue navy].
	self tap notNil ifTrue: [^ColorValue green].
	self well notNil ifTrue: [^ColorValue orange].
	^self povAtollCell</body>

<body package="Atoll" selector="povWellWater">povWellWater
	
	self wellWaterQuality = nil ifTrue: [^self state].
	self wellWaterQuality = #fresh ifTrue: [^ColorValue green].
	self wellWaterQuality = #brackish ifTrue: [^ColorValue orange].
	self wellWaterQuality = #salty ifTrue: [^ColorValue red].</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.AtollCell</class-id> <category>procedures</category>

<body package="Atoll" selector="calculateDistanceToPipe">calculateDistanceToPipe
	| pipeCell pipeEntry |
	self myIsland isNil ifTrue: [^9999].
	pipeCell := (self myIsland components 
				select: [:c | c numCol = self numCol]) detect: [:c | c waterPipe]
					ifNone: [^0].
	pipeEntry :=  ((self myIsland components select: [:c | c waterPipe]) asSortedCollection: [:x :y | x id &lt; y id]) first.
	pipeCell ifNil: [^9999].
	^((self distCell: pipeCell) + (pipeCell distCell: pipeEntry)).</body>

<body package="Atoll" selector="updateLensH:">updateLensH: aH 

	self lensH: (self lensH + aH).
	self lensH &lt; 0 ifTrue: [self lensH: 0].
	"self lensH &gt; 35 ifTrue: [self lensH: 35]."
	self lensh: self lensH * 0.03</body>

<body package="Atoll" selector="updateRisk">updateRisk
	self wellWaterQuality = #salty ifTrue: [self risk: self risk + 3].
	self wellWaterQuality = #brackish ifTrue: [self risk: self risk + 2]</body>
</methods>


<class>
<name>AgentPUB</name>
<environment>CormasNS.Models.Atoll</environment>
<super>CormasNS.Kernel.AgentCommLocation</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>myIslands </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>AtollCategory</category>
<attributes>
<package>Atoll</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.Atoll.AgentPUB</class-id> <category>init</category>

<body package="Atoll" selector="initAgentPUB">initAgentPUB
	super init.
	self myIslands: Island allInstances asOrderedCollection.</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.AgentPUB</class-id> <category>accessing</category>

<body package="Atoll" selector="myIslands">myIslands
	"Getter accessor without default value "
	^myIslands</body>

<body package="Atoll" selector="myIslands:">myIslands: anObject 
	myIslands := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.AgentPUB</class-id> <category>procedures</category>

<body package="Atoll" selector="treatDemand:fromTap:">treatDemand: x fromTap: aTap 
	"qty is the lowest volume of water between the left over in the pipe and the HH demand.
qty in L"
| qty demand available |
	available := (self myIslands detect: [:i | i name = #north] ifNone: []) waterInPipe.
	demand := x.
	qty := available min: demand.
	(self myIslands detect: [:i | i name = #north] ifNone: []) waterInPipe: (available - qty).
	demand := demand - qty.
	^x - demand</body>
</methods>


<class>
<name>Lens</name>
<environment>CormasNS.Models.Atoll</environment>
<super>CormasNS.Kernel.SpatialEntityAggregate</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>history netLoss netRech sumLoss sumRech </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>AtollCategory</category>
<attributes>
<package>Atoll</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.Atoll.Lens</class-id> <category>init</category>

<body package="Atoll" selector="initLensAttributes">initLensAttributes
	self netRech: 0.	"en mm/dec, moyenne des lensNetr des cellules a chaque step"
	self netLoss: 0.	"en mm/dec, moyenne des lensLoss des cellules a chaque step"
	self history: (Array new: 10 withAll: 400) asOrderedCollection.	"en mm/?"
	self sumLoss: 0.	"en mm/an, somme de tous les netLoss"
	self sumRech: 0	"en mm/an, somme de tous les netRech"</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Lens</class-id> <category>accessing</category>

<body package="Atoll" selector="history">history
	"Getter accessor without default value "
	^history</body>

<body package="Atoll" selector="history:">history: anObject 
	history := anObject</body>

<body package="Atoll" selector="myIsland">myIsland
	^(self at: 1) theCSE at: #Island</body>

<body package="Atoll" selector="netLoss:">netLoss: anObject 
	netLoss := anObject</body>

<body package="Atoll" selector="netRech:">netRech: anObject 
	netRech := anObject</body>

<body package="Atoll" selector="sumLoss:">sumLoss: anObject 
	sumLoss := anObject</body>

<body package="Atoll" selector="sumRech:">sumRech: anObject 
	sumRech := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Lens</class-id> <category>procedures</category>

<body package="Atoll" selector="calcMoyRech">calcMoyRech
	| sum |
	sum := 0.
	self history do: [:i | sum := sum + i].
	^(sum / (history size))</body>

<body package="Atoll" selector="calcNetLoss">calcNetLoss
	| sum |
	sum := 0.
	self components do: [:c | sum := sum + c wellLoss + c lossFromGalleries]. "sum en L/dec/lens"
	self netLoss: (sum / (AtollCell cellArea * self size)) rounded "netLoss en mm/dec"</body>

<body package="Atoll" selector="calcNetRech">calcNetRech
	"netRech = mean net recharge per cell of Lens per timeStep, in mm"

	self netRech: ((self components inject: 0 into: [:tot :c | tot + c myWaterBalance lensNetr]) / self size) rounded.</body>

<body package="Atoll" selector="updateHistory">updateHistory
	(self history)
		removeFirst;
		addLast: self sumRech - self sumLoss.
	self sumLoss: 0.
	self sumRech: 0</body>

<body package="Atoll" selector="updateLens">updateLens
	| balance |
	self updateLossDueToExtractionFromGalleries.
	self calcNetLoss.
	self sumLoss: self sumLoss + self netLoss.
	self sumRech: self sumRech + self netRech.
	balance := (self netRech - self netLoss - 0.02) / 1000.	"en mn"
	self components do: 
			[:c | 
			c updateLensH: balance.
			c updateWellWater]</body>

<body package="Atoll" selector="updateLossDueToExtractionFromGalleries">updateLossDueToExtractionFromGalleries
	| totPumpedPerCell |
	self myIsland myReserve
		ifTrue: 
			[totPumpedPerCell := self myIsland waterExtracted / self size. "l/decade" 
			self components do: [:c | c lossFromGalleries: totPumpedPerCell]]</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Lens</class-id> <category>probes</category>

<body package="Atoll" selector="maxDepth">maxDepth
| c |
	c := self components detect: [:cell | cell lensCenter notNil] ifNone: [].
	c lensH isNil not ifTrue: [^c lensH]</body>

<body package="Atoll" selector="netLoss">netLoss
	"Getter accessor without default value "
	^netLoss</body>

<body package="Atoll" selector="netRech">netRech
	"Getter accessor without default value "
	^netRech</body>

<body package="Atoll" selector="sumLoss">sumLoss
	"Getter accessor with default value = 0 "
	^sumLoss ifNil:[sumLoss := 0]</body>

<body package="Atoll" selector="sumRech">sumRech
	"Getter accessor with default value = 0 "
	^sumRech ifNil:[sumRech := 0]</body>

<body package="Atoll" selector="volumeLens">volumeLens
	| H |
	H := 0.
	self components do: [:aR | H := H + aR lensH].
	H := (H * AtollCell cellArea * 0.3).
	^H</body>
</methods>


<class>
<name>Atoll</name>
<environment>CormasNS.Models.Atoll</environment>
<super>CormasNS.Kernel.CormasModel</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>theAtollCells theLandStripes theLenss theIslands theHouseholds thePlayers theRelatives theAgentPUBs theWaterBalances theLanduses theBaresoils theCrops theTrees theWaterEquipments theRainTanks theTaps theWells </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>AtollCategory</category>
<attributes>
<package>Atoll</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Atoll.Atoll class</class-id> <category>description</category>

<body package="Atoll" selector="authors">authors
^ ' '	</body>

<body package="Atoll" selector="comments">comments
^ ''	</body>

<body package="Atoll" selector="creationDate">creationDate
^ ''	</body>

<body package="Atoll" selector="emails">emails
^ ' '	</body>

<body package="Atoll" selector="lastUpdate">lastUpdate
^ 'mercredi 12 avril 2006'	</body>

<body package="Atoll" selector="version">version
^ 'Atoll.st'	</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Atoll.Atoll</class-id> <category>init</category>

<body package="Atoll" selector="init">init
	super
		init;
		initCells;
		initAgents;
		initObjects;
		initData.
	self importDicoHydro.
	self initGrid.
	self initAgents.
	self initObjects</body>

<body package="Atoll" selector="init360">init360

"for simulation over 360 time steps"

	super
		init;
		initCells;
		initAgents;
		initObjects;
		initData.
	self importDicoHydro360.
	self initGrid.
	self initAgents.
	self initObjects</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Atoll</class-id> <category>control</category>

<body package="Atoll" selector="step:">step: t 
	self theIslands 
		do: [:anIsland | self theHouseholds addAll: anIsland createNewRelatives].
	self updateWaterEquipments.
	self updateLanduse.
	(self waterBalance: t) notNil 
		ifTrue: 
			[self theHouseholds do: [:aHH | aHH calculWaterDemands].
			self theWaterEquipments do: [:aWU | aWU updateAvailableVolume].
			self theIslands do: [:i | i updateExtractedWater].
			self theIslands 
				do: [:anIsland | anIsland sortedHouseHolds do: [:aHH | aHH updateWaterConsumption]].
			self theWells do: [:aW | aW updateLoss].
			self theIslands do: [:i | i myLens updateLens].
			self theIslands do: [:i | i updateRisk].
			self theAtollCells do: 
					[:c | 
					c
						defineVisualState;
						show].
			t \\ 36 = 0 ifTrue: [self updateYearLens: t]]</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Atoll</class-id> <category>accessing</category>

<body package="Atoll" selector="theAgentPUBs">theAgentPUBs
^theAgentPUBs ifNil:[theAgentPUBs := IndexedSet new]</body>

<body package="Atoll" selector="theAgentPUBs:">theAgentPUBs: x
theAgentPUBs := x</body>

<body package="Atoll" selector="theAtollCells">theAtollCells
^theAtollCells ifNil:[theAtollCells := IndexedSet new]</body>

<body package="Atoll" selector="theAtollCells:">theAtollCells: x
theAtollCells := x</body>

<body package="Atoll" selector="theBaresoils">theBaresoils
^theBaresoils ifNil:[theBaresoils := IndexedSet new]</body>

<body package="Atoll" selector="theBaresoils:">theBaresoils: x
theBaresoils := x</body>

<body package="Atoll" selector="theCrops">theCrops
^theCrops ifNil:[theCrops := IndexedSet new]</body>

<body package="Atoll" selector="theCrops:">theCrops: x
theCrops := x</body>

<body package="Atoll" selector="theHouseholds">theHouseholds
^theHouseholds ifNil:[theHouseholds := IndexedSet new]</body>

<body package="Atoll" selector="theHouseholds:">theHouseholds: x
theHouseholds := x</body>

<body package="Atoll" selector="theIslands">theIslands
^theIslands ifNil:[theIslands := IndexedSet new]</body>

<body package="Atoll" selector="theIslands:">theIslands: x
theIslands := x</body>

<body package="Atoll" selector="theLandStripes">theLandStripes
^theLandStripes ifNil:[theLandStripes := IndexedSet new]</body>

<body package="Atoll" selector="theLandStripes:">theLandStripes: x
theLandStripes := x</body>

<body package="Atoll" selector="theLanduses">theLanduses
^theLanduses ifNil:[theLanduses := IndexedSet new]</body>

<body package="Atoll" selector="theLanduses:">theLanduses: x
theLanduses := x</body>

<body package="Atoll" selector="theLenss">theLenss
^theLenss ifNil:[theLenss := IndexedSet new]</body>

<body package="Atoll" selector="theLenss:">theLenss: x
theLenss := x</body>

<body package="Atoll" selector="thePlayers">thePlayers
^thePlayers ifNil:[thePlayers := IndexedSet new]</body>

<body package="Atoll" selector="thePlayers:">thePlayers: x
thePlayers := x</body>

<body package="Atoll" selector="theRainTanks">theRainTanks
^theRainTanks ifNil:[theRainTanks := IndexedSet new]</body>

<body package="Atoll" selector="theRainTanks:">theRainTanks: x
theRainTanks := x</body>

<body package="Atoll" selector="theRelatives">theRelatives
^theRelatives ifNil:[theRelatives := IndexedSet new]</body>

<body package="Atoll" selector="theRelatives:">theRelatives: x
theRelatives := x</body>

<body package="Atoll" selector="theTaps">theTaps
^theTaps ifNil:[theTaps := IndexedSet new]</body>

<body package="Atoll" selector="theTaps:">theTaps: x
theTaps := x</body>

<body package="Atoll" selector="theTrees">theTrees
^theTrees ifNil:[theTrees := IndexedSet new]</body>

<body package="Atoll" selector="theTrees:">theTrees: x
theTrees := x</body>

<body package="Atoll" selector="theWaterBalances">theWaterBalances
^theWaterBalances ifNil:[theWaterBalances := IndexedSet new]</body>

<body package="Atoll" selector="theWaterBalances:">theWaterBalances: x
theWaterBalances := x</body>

<body package="Atoll" selector="theWaterEquipments">theWaterEquipments
^theWaterEquipments ifNil:[theWaterEquipments := IndexedSet new]</body>

<body package="Atoll" selector="theWaterEquipments:">theWaterEquipments: x
theWaterEquipments := x</body>

<body package="Atoll" selector="theWells">theWells
^theWells ifNil:[theWells := IndexedSet new]</body>

<body package="Atoll" selector="theWells:">theWells: x
theWells := x</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Atoll</class-id> <category>procedures</category>

<body package="Atoll" selector="updateLanduse">updateLanduse
	"update alert for salty cell and change crop or tree into baresoil"

	| x |
	self theLanduses do: 
			[:l | 
			x := l updateAlert.
			x notNil 
				ifTrue: 
					[self theLanduses add: x.
					self theBaresoils add: x]].
	self removeDestroyedEntities: Tree.
	self removeDestroyedEntities: Crop</body>

<body package="Atoll" selector="updateWaterEquipments">updateWaterEquipments
	"Update the collection of WaterEquipment after new relatives arrivals. Update the collection of PUBtaps"

	| collec |
	collec := Set new.
	self theAtollCells do: 
			[:c | 
			c collecAllWaterEquipments isEmpty not 
				ifTrue: [collec addAll: c collecAllWaterEquipments]].
	self theWaterEquipments: collec asOrderedCollection.
	self theRainTanks addAll: (self theWaterEquipments select: [:r | r class name = #RainTank]).
	self theTaps addAll: (self theWaterEquipments select: [:r | r class name = #Tap]).
	self theWells addAll: (self theWaterEquipments select: [:r | r class name = #Well]).</body>

<body package="Atoll" selector="updateYearLens:">updateYearLens: t 
	self theIslands do: [:i | i myLens updateHistory].
	self theIslands do: 
			[:i | 
			i myLens components do: 
					[:aC | 
					aC initZT: i myLens calcMoyRech.
					aC updateWellWater]]</body>

<body package="Atoll" selector="waterBalance:">waterBalance: t 
	| rainData etpData |
	rainData := Island readDicoHydro: t printString with: 'P'.
	etpData := Island readDicoHydro: t printString with: 'E10'.
	(rainData isNil or: [etpData isNil]) ifTrue: [^nil].
	Island rain: rainData.
	Island etp: etpData.
	self theLanduses do: [:l | l calculEP; calculEET; calculESM].
	self theWaterBalances do: [:c | c calculES; calculLensGWR; calculLensNetr].
	self theIslands do: [:i | i myLens calcNetRech]</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Atoll</class-id> <category>instance-creation</category>

<body package="Atoll" selector="importDicoHydro">importDicoHydro
	Island dicoHydro: Dictionary new.
	Island dicoHydro: (Cormas readCsv: 'dicHydroGame' myModel: 'Atoll').</body>

<body package="Atoll" selector="importDicoHydro360">importDicoHydro360
	Island dicoHydro: Dictionary new.
	Island dicoHydro: (Cormas readCsv: 'dicHydro360' myModel: 'Atoll').</body>

<body package="Atoll" selector="initAgents">initAgents

	self theAgentPUBs add: AgentPUB new initAgentPUB.
	self theIslands do: 
			[:i | 
			self theHouseholds addAll: i createAllHouseholds.
			self theHouseholds do: [:aHH | aHH agentPUB: self theAgentPUBs first]].
	self thePlayers addAll: (self theHouseholds select: [:h | h class name = #Player]).
	self theRelatives addAll: (self theHouseholds select: [:h | h class name = #Relative])</body>

<body package="Atoll" selector="initGrid">initGrid

	self spaceModel loadEnvironmentFromFile: 'Atoll.env'
		withPov: #povAtollCell.
	self initTwoIslands.
	self initLanduses.</body>

<body package="Atoll" selector="initLanduses">initLanduses
	(self theAtollCells select: [:c | c typeLanduse ~= #none]) 
		do: [:c | self theLanduses add: (c initCellLanduse: c typeLanduse)].
	self theBaresoils addAll: (self theLanduses select: [:t | t class name = #Baresoil]).
	self theCrops addAll: (self theLanduses select: [:t | t class name = #Crop]).
	self theTrees addAll: (self theLanduses select: [:t | t class name = #Tree]).</body>

<body package="Atoll" selector="initObjects">initObjects

	self theIslands 
		do: [:i | self theWaterBalances addAll: i createWaterBalances].
	self updateWaterEquipments</body>

<body package="Atoll" selector="initTwoIslands">initTwoIslands
	
	self spaceModel 
		setAggregates: Island
		from: AtollCell
		verifying: [:c | c state = #land].
	(self theIslands first)
		name: #north;
		maxSizeHH: 15.
	(self theIslands last)
		name: #south;
		maxSizeHH: 20.
	self theIslands do: [:i | i initIsland]</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Atoll</class-id> <category>probes</category>

<body package="Atoll" selector="nbOfBaresoils">nbOfBaresoils
	^self theBaresoils size</body>

<body package="Atoll" selector="nbOfCrop">nbOfCrop
	^self theCrops size</body>

<body package="Atoll" selector="nbOfHouseholds">nbOfHouseholds
	^self theHouseholds size</body>

<body package="Atoll" selector="nbOfLanduse">nbOfLanduse
	^self theLanduses size</body>

<body package="Atoll" selector="nbOfTrees">nbOfTrees
	^self theTrees size</body>
</methods>


<class>
<name>Island</name>
<environment>CormasNS.Models.Atoll</environment>
<super>CormasNS.Kernel.SpatialEntityAggregate</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>maxSizeHH myLandStripes myLens name nbPlayers playersLocations waterExtracted waterInPipe </inst-vars>
<class-inst-vars>dicoHydro etp rain </class-inst-vars>
<imports></imports>
<category>AtollCategory</category>
<attributes>
<package>Atoll</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Atoll.Island class</class-id> <category>accessing</category>

<body package="Atoll" selector="dicoHydro">dicoHydro
	"Getter accessor without default value "
	^dicoHydro</body>

<body package="Atoll" selector="dicoHydro:">dicoHydro: anObject 
	dicoHydro := anObject</body>

<body package="Atoll" selector="etp">etp
	"Getter accessor without default value "
	^etp</body>

<body package="Atoll" selector="etp:">etp: anObject 
	etp := anObject</body>

<body package="Atoll" selector="rain">rain
	"Getter accessor without default value "
	^rain</body>

<body package="Atoll" selector="rain:">rain: anObject 
	rain := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Island class</class-id> <category>procedures</category>

<body package="Atoll" selector="pumpingIntensity">pumpingIntensity
	^1</body>

<body package="Atoll" selector="pumpingPerUnit">pumpingPerUnit
	"50 m3 par jour, a exprimer en litre/decade"

	^(50 * 1000 * 10)</body>

<body package="Atoll" selector="readDicoHydro:with:">readDicoHydro: x with: y 
	| collecHydro data |
	collecHydro := self dicoHydro at: 'timeStep'.
	data := collecHydro indexOf: x.
	^data isZero 
		ifTrue: [nil]
		ifFalse: [((self dicoHydro at: y) at: data) asNumber]</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Atoll.Island</class-id> <category>init</category>

<body package="Atoll" selector="createAllHouseholds">createAllHouseholds
	| collecP collecH collec |

	collec := OrderedCollection new.
	collecP := self createPlayers.
	collecH := self createRelatives.
	collec addAll: collecP; addAll: collecH.
	self myLandowners
		do: 
			[:aHH | 
			aHH relatives: (collec select: [:aR | aHH ~= aR and: [aR patch landStripe = aHH patch landStripe]])].
	^collec</body>

<body package="Atoll" selector="createNewRelatives">createNewRelatives
	| collectNewRelatives |
	"to add in between 1 and 6 relatives to each landowner"

	collectNewRelatives := OrderedCollection new.
	self myLandowners do: 
			[:aLandowner | 
			collectNewRelatives addAll: (aLandowner 
						createNewRelativesIn: (aLandowner newRelativesLocations: aLandowner nbNewRelatives))].
	^collectNewRelatives</body>

<body package="Atoll" selector="createPlayerIn:ownership:">createPlayerIn: location ownership: aBoolean 
	| nH |
	nH := Player new.
	nH init: location ownership: aBoolean.
	nH name: nH patch dwelling.
	nH sizeHH: (Cormas randomFrom: 10 to: self maxSizeHH).
	nH initWaterEquipments.
	^nH</body>

<body package="Atoll" selector="createPlayers">createPlayers
	| allPlayers |
	allPlayers := OrderedCollection new.
	1 to: self nbPlayers
		do: 
			[:i | 
			allPlayers add: (self createPlayerIn: (self myHouseholdsLocations at: i)
						ownership: true)].
	^allPlayers</body>

<body package="Atoll" selector="createRelativeIn:ownership:">createRelativeIn: location ownership: aBoolean 
	| nH |
	nH := Relative new.
	(location theOccupants at: #Relative) isEmpty ifFalse: [self halt].
	nH init: location ownership: aBoolean.
	nH sizeHH: (Cormas randomFrom: 10 to: self maxSizeHH).
	nH initWaterEquipments.
	^nH</body>

<body package="Atoll" selector="createRelatives">createRelatives
	| collec |
	collec := OrderedCollection new.
	self nbPlayers + 1 to: self myLandStripes size
		do: 
			[:i | 
			collec add: (self createRelativeIn: (self myHouseholdsLocations at: i)
						ownership: true)].
	self myLandStripes size + 1 to: self myHouseholdsLocations size
		do: 
			[:i | 
			collec add: (self createRelativeIn: (self myHouseholdsLocations at: i)
						ownership: false)].
	^collec</body>

<body package="Atoll" selector="createWaterBalances">createWaterBalances
	| aWB collec |
	collec := OrderedCollection new.
	self components do: 
			[:c | 
			aWB := WaterBalance new.
			aWB isMovedTo: c.
			aWB initWaterBalance: c.
			collec add: aWB].
	^collec</body>

<body package="Atoll" selector="initIsland">initIsland
	super init.
	self components do: [:c | c initCellAttributes].
	self initLens.
	self components do: [:c | c updateWellWater].
	self initLandStripes.
	self nbPlayers: (Dialog request: 'Number of players on island ', self name asString,' ?'
				initialAnswer: self nbPlayers printString) asNumber.
	self playersLocations: ((self components 
				select: [:c | (c dwelling copyFrom: 1 to: 6) = 'player']) 
					asSortedCollection: 
						[:i :j | 
						(i dwelling copyFrom: 7 to: i dwelling size) asNumber 
							&lt; (j dwelling copyFrom: 7 to: j dwelling size) asNumber])</body>

<body package="Atoll" selector="initLandStripes">initLandStripes
| nbLandStripes collec |
	nbLandStripes := (self components 
				asSortedCollection: [:c1 :c2 | c1 landStripe &gt; c2 landStripe]) first 
				landStripe.
	1 to: nbLandStripes
		do: 
			[:i | 
			collec := self components select: [:c | c landStripe = i].
			collec isEmpty 
				ifFalse: 
					[self myLandStripes 
						add: (self spaceModel createAggregate: LandStripe from: collec)]]</body>

<body package="Atoll" selector="initLens">initLens
	| collec |
	self components do: [:c | c initLensCenter].
	self components do: [:c | c initZT: 400].
	collec := self components select: [:c | c lensH notNil and: [c lensH &gt; 0]].
	collec isEmpty 
		ifFalse: [self myLens: (self spaceModel createAggregate: Lens from: collec).
				self myLens initLensAttributes]</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Island</class-id> <category>accessing</category>

<body package="Atoll" selector="maxSizeHH">maxSizeHH
	"Getter accessor without default value "
	^maxSizeHH</body>

<body package="Atoll" selector="maxSizeHH:">maxSizeHH: anObject 
	maxSizeHH := anObject</body>

<body package="Atoll" selector="myHouseHolds">myHouseHolds
	| collec |
	collec := OrderedCollection new.
	self components 
		do: [:c | c myHouseHold notNil ifTrue: [collec add: c myHouseHold]].
	^collec</body>

<body package="Atoll" selector="myHouseholdsLocations">myHouseholdsLocations
	| collec |
	collec := OrderedCollection new.
	collec addAll: self playersLocations.
	collec addAll: (self components select: [:c | c dwelling = #relative]).
	^collec</body>

<body package="Atoll" selector="myLandowners">myLandowners
	^self myLandStripes collect: [:aLS | aLS landowner]</body>

<body package="Atoll" selector="myLandStripes">myLandStripes
	myLandStripes ifNil: [myLandStripes := OrderedCollection new].
	^myLandStripes</body>

<body package="Atoll" selector="myLandStripes:">myLandStripes: anObject 
	myLandStripes := anObject</body>

<body package="Atoll" selector="myLens">myLens
	"Getter accessor without default value "
	^myLens</body>

<body package="Atoll" selector="myLens:">myLens: anObject 
	myLens := anObject</body>

<body package="Atoll" selector="myPipe">myPipe
	^self components contains: [:c | c waterPipe]</body>

<body package="Atoll" selector="myReserve">myReserve
	^self components contains: [:c | c reserve = 1]</body>

<body package="Atoll" selector="name">name
	"Getter accessor without default value "
	^name</body>

<body package="Atoll" selector="name:">name: anObject 
	name := anObject</body>

<body package="Atoll" selector="nbPlayers">nbPlayers
	"Getter accessor with default value = 0 "
	^nbPlayers ifNil:[nbPlayers := 0]</body>

<body package="Atoll" selector="nbPlayers:">nbPlayers: anObject 
	nbPlayers := anObject</body>

<body package="Atoll" selector="playersLocations">playersLocations
	"Getter accessor without default value "
	^playersLocations</body>

<body package="Atoll" selector="playersLocations:">playersLocations: anObject 
	playersLocations := anObject</body>

<body package="Atoll" selector="waterExtracted">waterExtracted
	"Getter accessor with default value = 0 "
	^waterExtracted ifNil:[waterExtracted := 0]</body>

<body package="Atoll" selector="waterExtracted:">waterExtracted: anObject 
	waterExtracted := anObject</body>

<body package="Atoll" selector="waterInPipe">waterInPipe
	"Getter accessor with default value = 0 "
	^waterInPipe ifNil:[waterInPipe := 0]</body>

<body package="Atoll" selector="waterInPipe:">waterInPipe: anObject 
	waterInPipe := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Island</class-id> <category>procedures</category>

<body package="Atoll" selector="sortedHouseHolds">sortedHouseHolds
	| houseHoldsWithTap otherHouseHolds allHouseHolds |
	allHouseHolds := OrderedCollection new.
	houseHoldsWithTap := self myHouseHolds select: [:aHH | aHH myTap notNil].
	houseHoldsWithTap := houseHoldsWithTap asSortedCollection: 
			[:aHH1 :aHH2 | 
			aHH1 myTap distanceToPipeEntry &lt; aHH2 myTap distanceToPipeEntry].
	otherHouseHolds := self myHouseHolds select: [:aHH | aHH myTap isNil].
	allHouseHolds
		addAll: houseHoldsWithTap;
		addAll: otherHouseHolds.
	^allHouseHolds</body>

<body package="Atoll" selector="updateExtractedWater">updateExtractedWater
	| extractionFromGalleries |
	self myReserve ifFalse: [^self].
	extractionFromGalleries := ((self components select: [:c | c gallery]) size) 
				* self class pumpingPerUnit * self class pumpingIntensity.
	self waterExtracted: extractionFromGalleries.
	self waterInPipe: self waterInPipe + self waterExtracted * 1	"0% loss"</body>

<body package="Atoll" selector="updateRisk">updateRisk
	self components do: [:c | c updateRisk]</body>
</methods>


<class>
<name>LandStripe</name>
<environment>CormasNS.Models.Atoll</environment>
<super>CormasNS.Kernel.SpatialEntityAggregate</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>landowner </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>AtollCategory</category>
<attributes>
<package>Atoll</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.Atoll.LandStripe</class-id> <category>accessing</category>

<body package="Atoll" selector="emptyPlaces">emptyPlaces
	^self components select: 
			[:c | 
			(c theOccupants at: #Player) isEmpty 
				and: [(c theOccupants at: #Relative) isEmpty]]</body>

<body package="Atoll" selector="landowner">landowner
	"Getter accessor without default value "
	^landowner</body>

<body package="Atoll" selector="landowner:">landowner: anObject 
	landowner := anObject</body>
</methods>


<class>
<name>Relative</name>
<environment>CormasNS.Models.Atoll</environment>
<super>CormasNS.Models.Atoll.Household</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>AtollCategory</category>
<attributes>
<package>Atoll</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.Atoll.Relative</class-id> <category>control</category>

<body package="Atoll" selector="step">step
	"to be completed"</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Relative</class-id> <category>pov</category>

<body package="Atoll" selector="povRelative">povRelative
	^self myLand isNil ifTrue: [self class name] ifFalse: [#RelativePlayer]</body>
</methods>


<class>
<name>WaterEquipment</name>
<environment>CormasNS.Models.Atoll</environment>
<super>CormasNS.Kernel.ObjectLocation</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>availableVolume ownerWE </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>AtollCategory</category>
<attributes>
<package>Atoll</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.Atoll.WaterEquipment</class-id> <category>init</category>

<body package="Atoll" selector="init">init
	"to be completed. The inherited attributes should have been already initialized"
</body>

<body package="Atoll" selector="initEquipment:">initEquipment: aHH 
	self isMovedTo: aHH patch.
	self ownerWE: aHH.
	self availableVolume: 0</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.WaterEquipment</class-id> <category>accessing</category>

<body package="Atoll" selector="availableVolume">availableVolume
	"Getter accessor without default value "
	^availableVolume</body>

<body package="Atoll" selector="availableVolume:">availableVolume: anObject 
	availableVolume := anObject</body>

<body package="Atoll" selector="ownerWE">ownerWE
	"Getter accessor without default value "
	^ownerWE</body>

<body package="Atoll" selector="ownerWE:">ownerWE: anObject 
	ownerWE := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.WaterEquipment</class-id> <category>procedures</category>

<body package="Atoll" selector="giveWater:">giveWater: aDemand 
"returns the minimum between aDemand and the availableVolume, in L"
	| qty |
	qty := self availableVolume min: aDemand.
	self availableVolume: self availableVolume - qty.
	^qty</body>

<body package="Atoll" selector="updateAvailableVolume">updateAvailableVolume</body>
</methods>


<class>
<name>Tap</name>
<environment>CormasNS.Models.Atoll</environment>
<super>CormasNS.Models.Atoll.WaterEquipment</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>distanceToPipeEntry </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>AtollCategory</category>
<attributes>
<package>Atoll</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.Atoll.Tap</class-id> <category>init</category>

<body package="Atoll" selector="initEquipment:">initEquipment: aHH 
	super initEquipment: aHH.
	aHH myTap: self.</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Tap</class-id> <category>accessing</category>

<body package="Atoll" selector="distanceToPipeEntry">distanceToPipeEntry
	"Getter accessor with default value = 0 "
	distanceToPipeEntry isNil ifTrue:[self calculateDistanceToPipe]. 
	
	^distanceToPipeEntry</body>

<body package="Atoll" selector="distanceToPipeEntry:">distanceToPipeEntry: anObject 
	distanceToPipeEntry := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Tap</class-id> <category>procedures</category>

<body package="Atoll" selector="calculateDistanceToPipe">calculateDistanceToPipe
| pipeCell |
	pipeCell := (self patch myIsland components 
				select: [:c | c numCol = self patch numCol]) detect: [:c | c waterPipe]
					ifNone: [nil].
	pipeCell ifNil: [self halt].
	self distanceToPipeEntry: (self patch distCell: pipeCell)</body>

<body package="Atoll" selector="giveWater:">giveWater: aDemand 
	"the owner of the tap asks the agentPUB if he can provide aDemand. 
 Returns a qty of PUB water, in L"

	^self ownerWE agentPUB treatDemand: aDemand fromTap: self</body>
</methods>


<class>
<name>RainTank</name>
<environment>CormasNS.Models.Atoll</environment>
<super>CormasNS.Models.Atoll.WaterEquipment</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>AtollCategory</category>
<attributes>
<package>Atoll</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Atoll.RainTank class</class-id> <category>parameters</category>

<body package="Atoll" selector="maxRainTank">maxRainTank
	^4500</body>

<body package="Atoll" selector="maxStorage">maxStorage
	"maxumum capacity in L"

	^4500</body>

<body package="Atoll" selector="roofSurface">roofSurface
	"collecting roof surface in m2"

	^50</body>

<body package="Atoll" selector="tankSurface">tankSurface
	"tank surface in m2"

	^4</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Atoll.RainTank</class-id> <category>init</category>

<body package="Atoll" selector="initEquipment:">initEquipment: aHH 
	super initEquipment: aHH.
	aHH myRainTank: self.
	self availableVolume: self class maxRainTank / 2</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.RainTank</class-id> <category>procedures</category>

<body package="Atoll" selector="updateAvailableVolume">updateAvailableVolume
	"available water volume in the tank, updated according to the rain and etp.
	availableVolume in L"

	self availableVolume: self availableVolume + (Island rain * self class roofSurface) - (Island etp * self class tankSurface).
	self availableVolume &gt; self class maxStorage 
		ifTrue: [self availableVolume: self class maxStorage].
self availableVolume: (self availableVolume rounded asInteger)</body>
</methods>


<class>
<name>Well</name>
<environment>CormasNS.Models.Atoll</environment>
<super>CormasNS.Models.Atoll.WaterEquipment</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>AtollCategory</category>
<attributes>
<package>Atoll</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.Atoll.Well</class-id> <category>init</category>

<body package="Atoll" selector="initEquipment:">initEquipment: aHH 
	super initEquipment: aHH.
	aHH myWell: self.</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Well</class-id> <category>procedures</category>

<body package="Atoll" selector="updateAvailableVolume">updateAvailableVolume
	"Qmax = quantity max that can be extracted from the well in order to avoid more than 5mm lowering.
	 Qmax in L."
	| Const Qmax |
	Const := 3.14 * 15 / 2 ln.
	Qmax := Const * ((self patch lensh + self patch lensH - 0.005) ** 2 
						- ((self patch lensh + self patch lensH - (2 * 0.005)) ** 2)) 
				* 10 * 1000.	"Qmax in L/dec"
	self patch lensh + self patch lensH &lt; 0.01 ifTrue: [Qmax := 0].
	self availableVolume: Qmax rounded asInteger.</body>

<body package="Atoll" selector="updateLoss">updateLoss
	self patch wellLoss: (self ownerWE totalConsumptionForEq: #Well)</body>
</methods>


<class>
<name>Landuse</name>
<environment>CormasNS.Models.Atoll</environment>
<super>CormasNS.Kernel.ObjectLocation</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>alert EET EP ESM IS </inst-vars>
<class-inst-vars>ISmax Kc </class-inst-vars>
<imports></imports>
<category>AtollCategory</category>
<attributes>
<package>Atoll</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Atoll.Landuse class</class-id> <category>accessing</category>

<body package="Atoll" selector="ISmax">ISmax
	"Getter accessor with default value = 0 "
	^ISmax ifNil:[ISmax := 0]</body>

<body package="Atoll" selector="ISmax:">ISmax: anObject 
	ISmax := anObject</body>

<body package="Atoll" selector="Kc">Kc
	"Getter accessor with default value = 0 "
	^Kc ifNil:[Kc := 0]</body>

<body package="Atoll" selector="Kc:">Kc: anObject 
	Kc := anObject</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Atoll.Landuse</class-id> <category>init</category>

<body package="Atoll" selector="initLanduse">initLanduse
	super init.
	self IS: ((self class ISmax) /2).
	self EP: 0.
	self EET: 0.
	self ESM: 0.
	self alert: 0</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Landuse</class-id> <category>accessing</category>

<body package="Atoll" selector="alert">alert
	"Getter accessor without default value "
	^alert</body>

<body package="Atoll" selector="alert:">alert: anObject 
	alert := anObject</body>

<body package="Atoll" selector="EET">EET
	"Getter accessor without default value "
	^EET</body>

<body package="Atoll" selector="EET:">EET: anObject 
	EET := anObject</body>

<body package="Atoll" selector="EP">EP
	"Getter accessor without default value "
	^EP</body>

<body package="Atoll" selector="EP:">EP: anObject 
	EP := anObject</body>

<body package="Atoll" selector="ESM">ESM
	"Getter accessor without default value "
	^ESM</body>

<body package="Atoll" selector="ESM:">ESM: anObject 
	ESM := anObject</body>

<body package="Atoll" selector="IS">IS
	"Getter accessor without default value "
	^IS</body>

<body package="Atoll" selector="IS:">IS: anObject 
	IS := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Landuse</class-id> <category>procedures</category>

<body package="Atoll" selector="calculEET">calculEET
"EET = efective evaporation.
This method updates the etp according to the Landuse interception storage"
	Island etp &gt; self IS
		ifFalse: 
			[self EET: 0.
			self IS: (self IS - Island etp)]
		ifTrue: 
			[self EET: (Island etp - self IS).
			self IS: 0].</body>

<body package="Atoll" selector="calculEP">calculEP
"EP = effective rainfall.
This method updates the rain according to the Landuse interception storage"

	Island rain &gt; (self class ISmax - self IS)
		ifFalse: 
			[self EP: 0.
			self IS: self IS + Island rain]
		ifTrue: 
			[self EP: Island rain - (self class ISmax - self IS).
			self IS: self class ISmax]</body>

<body package="Atoll" selector="calculESM">calculESM
	"ESM = transpiration from shallow rooted Landuse.
	Kc = crop factor.
	This method is different for Tree"

	self ESM: self EET * self class Kc</body>

<body package="Atoll" selector="calculTranspiration">calculTranspiration
	"So far, only trees can pump into the groundwater"</body>

<body package="Atoll" selector="updateAlert">updateAlert

"Only for crop and tree. They can be turned into baresoil because of well water salinity"</body>
</methods>


<class>
<name>Tree</name>
<environment>CormasNS.Models.Atoll</environment>
<super>CormasNS.Models.Atoll.Landuse</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>AtollCategory</category>
<attributes>
<package>Atoll</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.Atoll.Tree</class-id> <category>procedures</category>

<body package="Atoll" selector="calculESM">calculESM
	"0.5 = 50% of roots are considered as shallow"
	self ESM: (self EET * self class Kc * 0.5)</body>

<body package="Atoll" selector="calculTranspiration">calculTranspiration
	^self EET * self class Kc * 0.5</body>

<body package="Atoll" selector="updateAlert">updateAlert
	"After 5 continuous timeStep of salty water, tree is tuned into baresoil"

	self patch wellWaterQuality = #salty 
		ifTrue: [self alert: self alert + 1]
		ifFalse: [self alert: 0].
	self alert = 5 
		ifTrue: 
			[self destroyed: true.
			^self patch initCellLanduse: #Baresoil].
	^nil</body>
</methods>


<class>
<name>Baresoil</name>
<environment>CormasNS.Models.Atoll</environment>
<super>CormasNS.Models.Atoll.Landuse</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>AtollCategory</category>
<attributes>
<package>Atoll</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.Atoll.Baresoil</class-id> <category>init</category>

<body package="Atoll" selector="init">init
	"to be completed. The inherited attributes should have been already initialized"
</body>
</methods>


<class>
<name>Crop</name>
<environment>CormasNS.Models.Atoll</environment>
<super>CormasNS.Models.Atoll.Landuse</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>AtollCategory</category>
<attributes>
<package>Atoll</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Atoll.Crop class</class-id> <category>accessing</category>

<body package="Atoll" selector="ISmax">ISmax
	"Getter accessor with default value = 0 "
	ISmax isNil ifTrue:[ISmax := 2]. 
	
	^ISmax</body>

<body package="Atoll" selector="ISmax:">ISmax: anObject 
	ISmax := anObject</body>

<body package="Atoll" selector="Kc">Kc
	"Getter accessor with default value = 0 "
	Kc isNil ifTrue:[Kc := 1]. 
	
	^Kc</body>

<body package="Atoll" selector="Kc:">Kc: anObject 
	Kc := anObject</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Atoll.Crop</class-id> <category>init</category>

<body package="Atoll" selector="init">init
	"to be completed. The inherited attributes should have been already initialized"
</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.Crop</class-id> <category>procedures</category>

<body package="Atoll" selector="updateAlert">updateAlert
	"After 5 continuous timeStep of salty water, crop is tuned into baresoil"

	self patch wellWaterQuality = #salty 
		ifTrue: [self alert: self alert + 1]
		ifFalse: [self alert: 0].
	self alert = 5 
		ifTrue: 
			[self destroyed: true.
			^self patch initCellLanduse: #Baresoil].
	^nil</body>
</methods>


<class>
<name>WaterBalance</name>
<environment>CormasNS.Models.Atoll</environment>
<super>CormasNS.Kernel.ObjectLocation</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>ES lensGWR lensNetr SMC SMCdef Xcess </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>AtollCategory</category>
<attributes>
<package>Atoll</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Atoll.WaterBalance class</class-id> <category>parameters</category>

<body package="Atoll" selector="FC">FC
	^0.15</body>

<body package="Atoll" selector="WP">WP
	^0.05</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Atoll.WaterBalance</class-id> <category>init</category>

<body package="Atoll" selector="initWaterBalance:">initWaterBalance: aCell

	self patch: aCell.
	self SMC: ((self SMCmax + self SMCmin) / 2).
	self Xcess: 0.
	self lensNetr: 0.
	self lensGWR: 0.
	self ES: 0.</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.WaterBalance</class-id> <category>accessing</category>

<body package="Atoll" selector="ES">ES
	"Getter accessor without default value "
	^ES</body>

<body package="Atoll" selector="ES:">ES: anObject 
	ES := anObject</body>

<body package="Atoll" selector="lensGWR">lensGWR
	"Getter accessor without default value "
	^lensGWR</body>

<body package="Atoll" selector="lensGWR:">lensGWR: anObject 
	lensGWR := anObject</body>

<body package="Atoll" selector="lensNetr">lensNetr
	"Getter accessor without default value "
	^lensNetr</body>

<body package="Atoll" selector="lensNetr:">lensNetr: anObject 
	lensNetr := anObject</body>

<body package="Atoll" selector="SMC">SMC
	"Getter accessor without default value "
	^SMC</body>

<body package="Atoll" selector="SMC:">SMC: anObject 
	SMC := anObject</body>

<body package="Atoll" selector="SMCdef">SMCdef
	"Getter accessor without default value "
	^SMCdef</body>

<body package="Atoll" selector="SMCdef:">SMCdef: anObject 
	SMCdef := anObject</body>

<body package="Atoll" selector="SMCmax">SMCmax
	^(self patch depth * self class FC) rounded</body>

<body package="Atoll" selector="SMCmin">SMCmin
	^(self patch depth * self class WP) rounded</body>

<body package="Atoll" selector="Xcess">Xcess
	"Getter accessor without default value "
	^Xcess</body>

<body package="Atoll" selector="Xcess:">Xcess: anObject 
	Xcess := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.Atoll.WaterBalance</class-id> <category>procedures</category>

<body package="Atoll" selector="calculES">calculES
	"ES = transpiration from shallow rooted Landuse adjusted with to the soil moisture ratio"

	| SMratio |
	SMratio := (self SMC - self SMCmin) / (self SMCmax - self SMCmin).
	self ES: self patch cellLanduse ESM * SMratio</body>

<body package="Atoll" selector="calculLensGWR">calculLensGWR
	"lensGWR =  lens gross recharge, before pumping from trees.
       Xcess = effective rain - transpiration from shallow rooted Landuse."

	self Xcess: self patch cellLanduse EP - self ES.
	self SMCdef: self SMCmax - self SMC.
	self Xcess &lt; self SMCdef 
		ifTrue: 
			[self SMC: self SMC + self Xcess.
			self SMC &lt; self SMCmin ifTrue: [self SMC: self SMCmin].
			self lensGWR: 0]
		ifFalse: 
			[self SMC: self SMCmax.
			self lensGWR: self Xcess - self SMCdef]</body>

<body package="Atoll" selector="calculLensNetr">calculLensNetr
	"lensNetr =  lens net recharge, after pumping from trees"

	self patch cellLanduse class = Tree 
		ifTrue: 
			[self lensNetr: self lensGWR - self patch cellLanduse calculTranspiration]
		ifFalse: [self lensNetr: self lensGWR]</body>
</methods>



</st-source>
